import refreshTokenHelper from "../../../utils/refreshTokenHelper"
import forceLogoutHelper from "../../../utils/forceLogoutHelper"
import errorHandlingHelper from "../../../utils/errorHandlingHelper"
import fetchHelper from "../../../utils/fetchHelper"

const handleFunc = async (event: any, authToken: any = null) => {
  let data: any = {}
  const config = useRuntimeConfig()
  const token = authToken ?? await getTokenHelper(event)
  const body = await readBody(event)

  let newObjValue = {}
  if(body.organizationId) {
    newObjValue = {...newObjValue, 
      AD_Org_ID: {
        id: body.organizationId,
        tableName: 'AD_Org'
      }
    }
  }

  const res: any = await fetchHelper(event, 'models/ad_sequence/'+body.id, 'PUT', token, {
    isActive: body.isActive,
    name: body.name,
    description: body.description,
    currentNext: body.currentNext,
    isAudited: body.isAudited,
    startNewYear: body.startNewYear,
    isTableID: body.isTableID,
    isAutoSequence: body.isAutoSequence,
    startNo: body.startNo,
    incrementNo: body.incrementNo,
    currentNextSys: body.currentNextSys,
    startNewMonth: body.startNewMonth,
    isOrgLevelSequence: body.isOrgLevelSequence,
    decimalPattern: body.decimalPattern,
    vFormat: body.vFormat,
    prefix: body.prefix,
    suffix: body.suffix,
    orgColumn: body.orgColumn,
    dateColumn: body.dateColumn,
    ...newObjValue,
    tableName: 'ad_sequence'
  })
  if(res) {
    data = res
    data['status'] = 200
    data['message'] = ''
  }

  return data
}

export default defineEventHandler(async (event) => {
  let data: any = {}

  try {
    data = await handleFunc(event)
  } catch(err: any) {
    try {
      let authToken: any = await refreshTokenHelper(event)
      data = await handleFunc(event, authToken)
    } catch(error) {
      data = errorHandlingHelper(err?.data ?? err, error?.data ?? error)
      forceLogoutHelper(event, data)
    }
  }

  return data
})